/* Generated by generate-js-builtins do not hand edit. */

/*
 * Copyright (C) 2014 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */



#include "config.h"

#include "JSCBuiltins.h"

#include "BuiltinExecutables.h"
#include "Executable.h"
#include "JSCellInlines.h"
#include "VM.h"

namespace JSC {

const char* s_arrayPrototypeEveryCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.every requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.every requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.every callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    \n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (!(i in array))\n" \
    "            continue;\n" \
    "        if (!callback.@call(thisArg, array[i], i, array))\n" \
    "            return false;\n" \
    "    }\n" \
    "    \n" \
    "    return true;\n" \
    "})\n" \
;

const int s_arrayPrototypeEveryCodeLength = 760;

const char* s_arrayPrototypeForEachCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.forEach requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.forEach requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.forEach callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    \n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (i in array)\n" \
    "            callback.@call(thisArg, array[i], i, array);\n" \
    "    }\n" \
    "})\n" \
;

const int s_arrayPrototypeForEachCodeLength = 692;

const char* s_arrayPrototypeFilterCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.filter requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.filter requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.filter callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    var result = [];\n" \
    "    var nextIndex = 0;\n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (!(i in array))\n" \
    "            continue;\n" \
    "        var current = array[i]\n" \
    "        if (callback.@call(thisArg, current, i, array))\n" \
    "            result[nextIndex++] = current;\n" \
    "    }\n" \
    "    return result;\n" \
    "})\n" \
;

const int s_arrayPrototypeFilterCodeLength = 845;

const char* s_arrayPrototypeMapCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.map requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.map requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.map callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    var result = [];\n" \
    "    result.length = length;\n" \
    "    var nextIndex = 0;\n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (!(i in array))\n" \
    "            continue;\n" \
    "        result[i] = callback.@call(thisArg, array[i], i, array)\n" \
    "    }\n" \
    "    return result;\n" \
    "})\n" \
;

const int s_arrayPrototypeMapCodeLength = 798;

const char* s_arrayPrototypeSomeCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.some requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.some requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.some callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (!(i in array))\n" \
    "            continue;\n" \
    "        if (callback.@call(thisArg, array[i], i, array))\n" \
    "            return true;\n" \
    "    }\n" \
    "    return false;\n" \
    "})\n" \
;

const int s_arrayPrototypeSomeCodeLength = 746;

const char* s_arrayPrototypeFillCode =
    "(function (value )\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.fill requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.fill requires that |this| not be undefined\");\n" \
    "    var O = @Object(this);\n" \
    "    var len = O.length >>> 0;\n" \
    "    var relativeStart = 0;\n" \
    "    if (arguments.length > 1 && arguments[1] !== undefined)\n" \
    "        relativeStart = arguments[1] | 0;\n" \
    "    var k = 0;\n" \
    "    if (relativeStart < 0) {\n" \
    "        k = len + relativeStart;\n" \
    "        if (k < 0)\n" \
    "            k = 0;\n" \
    "    } else {\n" \
    "        k = relativeStart;\n" \
    "        if (k > len)\n" \
    "            k = len;\n" \
    "    }\n" \
    "    var relativeEnd = len;\n" \
    "    if (arguments.length > 2 && arguments[2] !== undefined)\n" \
    "        relativeEnd = arguments[2] | 0;\n" \
    "    var final = 0;\n" \
    "    if (relativeEnd < 0) {\n" \
    "        final = len + relativeEnd;\n" \
    "        if (final < 0)\n" \
    "            final = 0;\n" \
    "    } else {\n" \
    "        final = relativeEnd;\n" \
    "        if (final > len)\n" \
    "            final = len;\n" \
    "    }\n" \
    "    for (; k < final; k++)\n" \
    "        O[k] = value;\n" \
    "    return O;\n" \
    "})\n" \
;

const int s_arrayPrototypeFillCodeLength = 1081;

const char* s_arrayPrototypeFindCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.find requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.find requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.find callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (!(i in array))\n" \
    "            continue;\n" \
    "        if (callback.@call(thisArg, array[i], i, array))\n" \
    "            return array[i];\n" \
    "    }\n" \
    "    return undefined;\n" \
    "})\n" \
;

const int s_arrayPrototypeFindCodeLength = 754;

const char* s_arrayPrototypeFindIndexCode =
    "(function (callback ) {\n" \
    "    \"use strict\";\n" \
    "    if (this === null)\n" \
    "        throw new @TypeError(\"Array.prototype.findIndex requires that |this| not be null\");\n" \
    "    \n" \
    "    if (this === undefined)\n" \
    "        throw new @TypeError(\"Array.prototype.findIndex requires that |this| not be undefined\");\n" \
    "    \n" \
    "    var array = @Object(this);\n" \
    "    var length = array.length >>> 0;\n" \
    "    \n" \
    "    if (typeof callback !== \"function\")\n" \
    "        throw new @TypeError(\"Array.prototype.findIndex callback must be a function\");\n" \
    "    \n" \
    "    var thisArg = arguments.length > 1 ? arguments[1] : undefined;\n" \
    "    for (var i = 0; i < length; i++) {\n" \
    "        if (!(i in array))\n" \
    "            continue;\n" \
    "        if (callback.@call(thisArg, array[i], i, array))\n" \
    "            return i;\n" \
    "    }\n" \
    "    return -1;\n" \
    "})\n" \
;

const int s_arrayPrototypeFindIndexCodeLength = 755;

const char* s_functionPrototypeCallCode =
    "(function (thisArgument) {\n" \
    "    \"use strict\";\n" \
    "    return this.@call(...arguments);\n" \
    "})\n" \
;

const int s_functionPrototypeCallCodeLength = 85;

const char* s_functionPrototypeApplyCode =
    "(function (thisValue, argumentValues) {\n" \
    "    \"use strict\";\n" \
    "    return this.@apply(thisValue, argumentValues);\n" \
    "})\n" \
;

const int s_functionPrototypeApplyCodeLength = 112;

const char* s_promisePrototypeCatchCode =
    "(function (onRejected) {\n" \
    "    \"use strict\";\n" \
    "\n" \
    "    return this.then(undefined, onRejected);\n" \
    "})\n" \
;

const int s_promisePrototypeCatchCodeLength = 92;


FunctionExecutable* createBuiltinExecutable(VM& vm, UnlinkedFunctionExecutable* unlinkedExecutable, const SourceCode& source)
{
    unsigned lineCount = unlinkedExecutable->lineCount();
    unsigned startColumn = 1;
    unsigned sourceLength = unlinkedExecutable->sourceLength();
    bool endColumnIsOnStartLine = !lineCount;
    unsigned endColumnExcludingBraces = unlinkedExecutable->unlinkedBodyEndColumn() + (endColumnIsOnStartLine ? 0 : 1);
    unsigned startOffset = unlinkedExecutable->startOffset();
    unsigned startOffsetExcludingOpenBrace = startOffset + 1;
    unsigned endOffsetExcludingCloseBrace = startOffset + sourceLength - 1;
    SourceCode bodySource(source.provider(), startOffsetExcludingOpenBrace, endOffsetExcludingCloseBrace, 0, startColumn);
    return FunctionExecutable::create(vm, bodySource, unlinkedExecutable, 0, lineCount, startColumn, endColumnExcludingBraces, false);
}

#define JSC_DEFINE_BUILTIN_GENERATOR(codeName, functionName, argumentCount) \
FunctionExecutable* codeName##Generator(VM& vm) \
{ \
    return createBuiltinExecutable(vm, vm.builtinExecutables()->codeName##Executable(), vm.builtinExecutables()->codeName##Source()); \
}

JSC_FOREACH_BUILTIN(JSC_DEFINE_BUILTIN_GENERATOR)
#undef JSC_DEFINE_BUILTIN_GENERATOR
}

