/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * This file was generated by the dom/make_names.pl script.
 *
 * Copyright (C) 2005, 2006, 2007, 2008, 2009, 2013 Apple Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef HTMLElementTypeHelpers_h
#define HTMLElementTypeHelpers_h

#include "HTMLNames.h"

namespace WebCore {

class HTMLAnchorElement;
void isHTMLAnchorElement(const HTMLAnchorElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLAnchorElement(const HTMLAnchorElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLAnchorElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::aTag); }
inline bool isHTMLAnchorElement(const Node& node) { return node.hasTagName(HTMLNames::aTag); }
inline bool isHTMLAnchorElement(const HTMLElement* element) { ASSERT(element); return isHTMLAnchorElement(*element); }
inline bool isHTMLAnchorElement(const Node* node) { ASSERT(node); return isHTMLAnchorElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLAnchorElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLAnchorElement(node); }
};

class HTMLAppletElement;
void isHTMLAppletElement(const HTMLAppletElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLAppletElement(const HTMLAppletElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLAppletElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::appletTag); }
inline bool isHTMLAppletElement(const Node& node) { return node.hasTagName(HTMLNames::appletTag); }
inline bool isHTMLAppletElement(const HTMLElement* element) { ASSERT(element); return isHTMLAppletElement(*element); }
inline bool isHTMLAppletElement(const Node* node) { ASSERT(node); return isHTMLAppletElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLAppletElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLAppletElement(node); }
};

class HTMLAreaElement;
void isHTMLAreaElement(const HTMLAreaElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLAreaElement(const HTMLAreaElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLAreaElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::areaTag); }
inline bool isHTMLAreaElement(const Node& node) { return node.hasTagName(HTMLNames::areaTag); }
inline bool isHTMLAreaElement(const HTMLElement* element) { ASSERT(element); return isHTMLAreaElement(*element); }
inline bool isHTMLAreaElement(const Node* node) { ASSERT(node); return isHTMLAreaElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLAreaElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLAreaElement(node); }
};

class HTMLAudioElement;
void isHTMLAudioElement(const HTMLAudioElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLAudioElement(const HTMLAudioElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLAudioElement(const HTMLElement& element) { return !element.isHTMLUnknownElement() && element.hasTagName(HTMLNames::audioTag); }
inline bool isHTMLAudioElement(const Node& node) { return node.isHTMLElement() && isHTMLAudioElement(toHTMLElement(node)); }
inline bool isHTMLAudioElement(const HTMLElement* element) { ASSERT(element); return isHTMLAudioElement(*element); }
inline bool isHTMLAudioElement(const Node* node) { ASSERT(node); return isHTMLAudioElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLAudioElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLAudioElement(node); }
};

class HTMLBaseElement;
void isHTMLBaseElement(const HTMLBaseElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLBaseElement(const HTMLBaseElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLBaseElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::baseTag); }
inline bool isHTMLBaseElement(const Node& node) { return node.hasTagName(HTMLNames::baseTag); }
inline bool isHTMLBaseElement(const HTMLElement* element) { ASSERT(element); return isHTMLBaseElement(*element); }
inline bool isHTMLBaseElement(const Node* node) { ASSERT(node); return isHTMLBaseElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLBaseElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLBaseElement(node); }
};

class HTMLBodyElement;
void isHTMLBodyElement(const HTMLBodyElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLBodyElement(const HTMLBodyElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLBodyElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::bodyTag); }
inline bool isHTMLBodyElement(const Node& node) { return node.hasTagName(HTMLNames::bodyTag); }
inline bool isHTMLBodyElement(const HTMLElement* element) { ASSERT(element); return isHTMLBodyElement(*element); }
inline bool isHTMLBodyElement(const Node* node) { ASSERT(node); return isHTMLBodyElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLBodyElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLBodyElement(node); }
};

class HTMLCanvasElement;
void isHTMLCanvasElement(const HTMLCanvasElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLCanvasElement(const HTMLCanvasElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLCanvasElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::canvasTag); }
inline bool isHTMLCanvasElement(const Node& node) { return node.hasTagName(HTMLNames::canvasTag); }
inline bool isHTMLCanvasElement(const HTMLElement* element) { ASSERT(element); return isHTMLCanvasElement(*element); }
inline bool isHTMLCanvasElement(const Node* node) { ASSERT(node); return isHTMLCanvasElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLCanvasElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLCanvasElement(node); }
};

class HTMLTableCaptionElement;
void isHTMLTableCaptionElement(const HTMLTableCaptionElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTableCaptionElement(const HTMLTableCaptionElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTableCaptionElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::captionTag); }
inline bool isHTMLTableCaptionElement(const Node& node) { return node.hasTagName(HTMLNames::captionTag); }
inline bool isHTMLTableCaptionElement(const HTMLElement* element) { ASSERT(element); return isHTMLTableCaptionElement(*element); }
inline bool isHTMLTableCaptionElement(const Node* node) { ASSERT(node); return isHTMLTableCaptionElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTableCaptionElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTableCaptionElement(node); }
};

class HTMLDataListElement;
void isHTMLDataListElement(const HTMLDataListElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLDataListElement(const HTMLDataListElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLDataListElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::datalistTag); }
inline bool isHTMLDataListElement(const Node& node) { return node.hasTagName(HTMLNames::datalistTag); }
inline bool isHTMLDataListElement(const HTMLElement* element) { ASSERT(element); return isHTMLDataListElement(*element); }
inline bool isHTMLDataListElement(const Node* node) { ASSERT(node); return isHTMLDataListElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLDataListElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLDataListElement(node); }
};

class HTMLDetailsElement;
void isHTMLDetailsElement(const HTMLDetailsElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLDetailsElement(const HTMLDetailsElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLDetailsElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::detailsTag); }
inline bool isHTMLDetailsElement(const Node& node) { return node.hasTagName(HTMLNames::detailsTag); }
inline bool isHTMLDetailsElement(const HTMLElement* element) { ASSERT(element); return isHTMLDetailsElement(*element); }
inline bool isHTMLDetailsElement(const Node* node) { ASSERT(node); return isHTMLDetailsElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLDetailsElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLDetailsElement(node); }
};

class HTMLDivElement;
void isHTMLDivElement(const HTMLDivElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLDivElement(const HTMLDivElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLDivElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::divTag); }
inline bool isHTMLDivElement(const Node& node) { return node.hasTagName(HTMLNames::divTag); }
inline bool isHTMLDivElement(const HTMLElement* element) { ASSERT(element); return isHTMLDivElement(*element); }
inline bool isHTMLDivElement(const Node* node) { ASSERT(node); return isHTMLDivElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLDivElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLDivElement(node); }
};

class HTMLEmbedElement;
void isHTMLEmbedElement(const HTMLEmbedElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLEmbedElement(const HTMLEmbedElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLEmbedElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::embedTag); }
inline bool isHTMLEmbedElement(const Node& node) { return node.hasTagName(HTMLNames::embedTag); }
inline bool isHTMLEmbedElement(const HTMLElement* element) { ASSERT(element); return isHTMLEmbedElement(*element); }
inline bool isHTMLEmbedElement(const Node* node) { ASSERT(node); return isHTMLEmbedElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLEmbedElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLEmbedElement(node); }
};

class HTMLFieldSetElement;
void isHTMLFieldSetElement(const HTMLFieldSetElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLFieldSetElement(const HTMLFieldSetElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLFieldSetElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::fieldsetTag); }
inline bool isHTMLFieldSetElement(const Node& node) { return node.hasTagName(HTMLNames::fieldsetTag); }
inline bool isHTMLFieldSetElement(const HTMLElement* element) { ASSERT(element); return isHTMLFieldSetElement(*element); }
inline bool isHTMLFieldSetElement(const Node* node) { ASSERT(node); return isHTMLFieldSetElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLFieldSetElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLFieldSetElement(node); }
};

class HTMLFormElement;
void isHTMLFormElement(const HTMLFormElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLFormElement(const HTMLFormElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLFormElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::formTag); }
inline bool isHTMLFormElement(const Node& node) { return node.hasTagName(HTMLNames::formTag); }
inline bool isHTMLFormElement(const HTMLElement* element) { ASSERT(element); return isHTMLFormElement(*element); }
inline bool isHTMLFormElement(const Node* node) { ASSERT(node); return isHTMLFormElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLFormElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLFormElement(node); }
};

class HTMLFrameElement;
void isHTMLFrameElement(const HTMLFrameElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLFrameElement(const HTMLFrameElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLFrameElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::frameTag); }
inline bool isHTMLFrameElement(const Node& node) { return node.hasTagName(HTMLNames::frameTag); }
inline bool isHTMLFrameElement(const HTMLElement* element) { ASSERT(element); return isHTMLFrameElement(*element); }
inline bool isHTMLFrameElement(const Node* node) { ASSERT(node); return isHTMLFrameElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLFrameElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLFrameElement(node); }
};

class HTMLFrameSetElement;
void isHTMLFrameSetElement(const HTMLFrameSetElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLFrameSetElement(const HTMLFrameSetElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLFrameSetElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::framesetTag); }
inline bool isHTMLFrameSetElement(const Node& node) { return node.hasTagName(HTMLNames::framesetTag); }
inline bool isHTMLFrameSetElement(const HTMLElement* element) { ASSERT(element); return isHTMLFrameSetElement(*element); }
inline bool isHTMLFrameSetElement(const Node* node) { ASSERT(node); return isHTMLFrameSetElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLFrameSetElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLFrameSetElement(node); }
};

class HTMLHeadElement;
void isHTMLHeadElement(const HTMLHeadElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLHeadElement(const HTMLHeadElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLHeadElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::headTag); }
inline bool isHTMLHeadElement(const Node& node) { return node.hasTagName(HTMLNames::headTag); }
inline bool isHTMLHeadElement(const HTMLElement* element) { ASSERT(element); return isHTMLHeadElement(*element); }
inline bool isHTMLHeadElement(const Node* node) { ASSERT(node); return isHTMLHeadElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLHeadElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLHeadElement(node); }
};

class HTMLHtmlElement;
void isHTMLHtmlElement(const HTMLHtmlElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLHtmlElement(const HTMLHtmlElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLHtmlElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::htmlTag); }
inline bool isHTMLHtmlElement(const Node& node) { return node.hasTagName(HTMLNames::htmlTag); }
inline bool isHTMLHtmlElement(const HTMLElement* element) { ASSERT(element); return isHTMLHtmlElement(*element); }
inline bool isHTMLHtmlElement(const Node* node) { ASSERT(node); return isHTMLHtmlElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLHtmlElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLHtmlElement(node); }
};

class HTMLIFrameElement;
void isHTMLIFrameElement(const HTMLIFrameElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLIFrameElement(const HTMLIFrameElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLIFrameElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::iframeTag); }
inline bool isHTMLIFrameElement(const Node& node) { return node.hasTagName(HTMLNames::iframeTag); }
inline bool isHTMLIFrameElement(const HTMLElement* element) { ASSERT(element); return isHTMLIFrameElement(*element); }
inline bool isHTMLIFrameElement(const Node* node) { ASSERT(node); return isHTMLIFrameElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLIFrameElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLIFrameElement(node); }
};

class HTMLImageElement;
void isHTMLImageElement(const HTMLImageElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLImageElement(const HTMLImageElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLImageElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::imgTag); }
inline bool isHTMLImageElement(const Node& node) { return node.hasTagName(HTMLNames::imgTag); }
inline bool isHTMLImageElement(const HTMLElement* element) { ASSERT(element); return isHTMLImageElement(*element); }
inline bool isHTMLImageElement(const Node* node) { ASSERT(node); return isHTMLImageElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLImageElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLImageElement(node); }
};

class HTMLInputElement;
void isHTMLInputElement(const HTMLInputElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLInputElement(const HTMLInputElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLInputElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::inputTag); }
inline bool isHTMLInputElement(const Node& node) { return node.hasTagName(HTMLNames::inputTag); }
inline bool isHTMLInputElement(const HTMLElement* element) { ASSERT(element); return isHTMLInputElement(*element); }
inline bool isHTMLInputElement(const Node* node) { ASSERT(node); return isHTMLInputElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLInputElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLInputElement(node); }
};

class HTMLLabelElement;
void isHTMLLabelElement(const HTMLLabelElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLLabelElement(const HTMLLabelElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLLabelElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::labelTag); }
inline bool isHTMLLabelElement(const Node& node) { return node.hasTagName(HTMLNames::labelTag); }
inline bool isHTMLLabelElement(const HTMLElement* element) { ASSERT(element); return isHTMLLabelElement(*element); }
inline bool isHTMLLabelElement(const Node* node) { ASSERT(node); return isHTMLLabelElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLLabelElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLLabelElement(node); }
};

class HTMLLegendElement;
void isHTMLLegendElement(const HTMLLegendElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLLegendElement(const HTMLLegendElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLLegendElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::legendTag); }
inline bool isHTMLLegendElement(const Node& node) { return node.hasTagName(HTMLNames::legendTag); }
inline bool isHTMLLegendElement(const HTMLElement* element) { ASSERT(element); return isHTMLLegendElement(*element); }
inline bool isHTMLLegendElement(const Node* node) { ASSERT(node); return isHTMLLegendElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLLegendElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLLegendElement(node); }
};

class HTMLLinkElement;
void isHTMLLinkElement(const HTMLLinkElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLLinkElement(const HTMLLinkElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLLinkElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::linkTag); }
inline bool isHTMLLinkElement(const Node& node) { return node.hasTagName(HTMLNames::linkTag); }
inline bool isHTMLLinkElement(const HTMLElement* element) { ASSERT(element); return isHTMLLinkElement(*element); }
inline bool isHTMLLinkElement(const Node* node) { ASSERT(node); return isHTMLLinkElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLLinkElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLLinkElement(node); }
};

class HTMLMapElement;
void isHTMLMapElement(const HTMLMapElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLMapElement(const HTMLMapElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLMapElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::mapTag); }
inline bool isHTMLMapElement(const Node& node) { return node.hasTagName(HTMLNames::mapTag); }
inline bool isHTMLMapElement(const HTMLElement* element) { ASSERT(element); return isHTMLMapElement(*element); }
inline bool isHTMLMapElement(const Node* node) { ASSERT(node); return isHTMLMapElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLMapElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLMapElement(node); }
};

class HTMLMarqueeElement;
void isHTMLMarqueeElement(const HTMLMarqueeElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLMarqueeElement(const HTMLMarqueeElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLMarqueeElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::marqueeTag); }
inline bool isHTMLMarqueeElement(const Node& node) { return node.hasTagName(HTMLNames::marqueeTag); }
inline bool isHTMLMarqueeElement(const HTMLElement* element) { ASSERT(element); return isHTMLMarqueeElement(*element); }
inline bool isHTMLMarqueeElement(const Node* node) { ASSERT(node); return isHTMLMarqueeElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLMarqueeElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLMarqueeElement(node); }
};

class HTMLMetaElement;
void isHTMLMetaElement(const HTMLMetaElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLMetaElement(const HTMLMetaElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLMetaElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::metaTag); }
inline bool isHTMLMetaElement(const Node& node) { return node.hasTagName(HTMLNames::metaTag); }
inline bool isHTMLMetaElement(const HTMLElement* element) { ASSERT(element); return isHTMLMetaElement(*element); }
inline bool isHTMLMetaElement(const Node* node) { ASSERT(node); return isHTMLMetaElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLMetaElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLMetaElement(node); }
};

class HTMLMeterElement;
void isHTMLMeterElement(const HTMLMeterElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLMeterElement(const HTMLMeterElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLMeterElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::meterTag); }
inline bool isHTMLMeterElement(const Node& node) { return node.hasTagName(HTMLNames::meterTag); }
inline bool isHTMLMeterElement(const HTMLElement* element) { ASSERT(element); return isHTMLMeterElement(*element); }
inline bool isHTMLMeterElement(const Node* node) { ASSERT(node); return isHTMLMeterElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLMeterElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLMeterElement(node); }
};

class HTMLObjectElement;
void isHTMLObjectElement(const HTMLObjectElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLObjectElement(const HTMLObjectElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLObjectElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::objectTag); }
inline bool isHTMLObjectElement(const Node& node) { return node.hasTagName(HTMLNames::objectTag); }
inline bool isHTMLObjectElement(const HTMLElement* element) { ASSERT(element); return isHTMLObjectElement(*element); }
inline bool isHTMLObjectElement(const Node* node) { ASSERT(node); return isHTMLObjectElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLObjectElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLObjectElement(node); }
};

class HTMLOListElement;
void isHTMLOListElement(const HTMLOListElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLOListElement(const HTMLOListElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLOListElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::olTag); }
inline bool isHTMLOListElement(const Node& node) { return node.hasTagName(HTMLNames::olTag); }
inline bool isHTMLOListElement(const HTMLElement* element) { ASSERT(element); return isHTMLOListElement(*element); }
inline bool isHTMLOListElement(const Node* node) { ASSERT(node); return isHTMLOListElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLOListElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLOListElement(node); }
};

class HTMLOptGroupElement;
void isHTMLOptGroupElement(const HTMLOptGroupElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLOptGroupElement(const HTMLOptGroupElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLOptGroupElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::optgroupTag); }
inline bool isHTMLOptGroupElement(const Node& node) { return node.hasTagName(HTMLNames::optgroupTag); }
inline bool isHTMLOptGroupElement(const HTMLElement* element) { ASSERT(element); return isHTMLOptGroupElement(*element); }
inline bool isHTMLOptGroupElement(const Node* node) { ASSERT(node); return isHTMLOptGroupElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLOptGroupElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLOptGroupElement(node); }
};

class HTMLOptionElement;
void isHTMLOptionElement(const HTMLOptionElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLOptionElement(const HTMLOptionElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLOptionElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::optionTag); }
inline bool isHTMLOptionElement(const Node& node) { return node.hasTagName(HTMLNames::optionTag); }
inline bool isHTMLOptionElement(const HTMLElement* element) { ASSERT(element); return isHTMLOptionElement(*element); }
inline bool isHTMLOptionElement(const Node* node) { ASSERT(node); return isHTMLOptionElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLOptionElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLOptionElement(node); }
};

class HTMLParamElement;
void isHTMLParamElement(const HTMLParamElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLParamElement(const HTMLParamElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLParamElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::paramTag); }
inline bool isHTMLParamElement(const Node& node) { return node.hasTagName(HTMLNames::paramTag); }
inline bool isHTMLParamElement(const HTMLElement* element) { ASSERT(element); return isHTMLParamElement(*element); }
inline bool isHTMLParamElement(const Node* node) { ASSERT(node); return isHTMLParamElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLParamElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLParamElement(node); }
};

class HTMLProgressElement;
void isHTMLProgressElement(const HTMLProgressElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLProgressElement(const HTMLProgressElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLProgressElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::progressTag); }
inline bool isHTMLProgressElement(const Node& node) { return node.hasTagName(HTMLNames::progressTag); }
inline bool isHTMLProgressElement(const HTMLElement* element) { ASSERT(element); return isHTMLProgressElement(*element); }
inline bool isHTMLProgressElement(const Node* node) { ASSERT(node); return isHTMLProgressElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLProgressElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLProgressElement(node); }
};

class HTMLScriptElement;
void isHTMLScriptElement(const HTMLScriptElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLScriptElement(const HTMLScriptElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLScriptElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::scriptTag); }
inline bool isHTMLScriptElement(const Node& node) { return node.hasTagName(HTMLNames::scriptTag); }
inline bool isHTMLScriptElement(const HTMLElement* element) { ASSERT(element); return isHTMLScriptElement(*element); }
inline bool isHTMLScriptElement(const Node* node) { ASSERT(node); return isHTMLScriptElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLScriptElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLScriptElement(node); }
};

class HTMLSelectElement;
void isHTMLSelectElement(const HTMLSelectElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLSelectElement(const HTMLSelectElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLSelectElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::selectTag); }
inline bool isHTMLSelectElement(const Node& node) { return node.hasTagName(HTMLNames::selectTag); }
inline bool isHTMLSelectElement(const HTMLElement* element) { ASSERT(element); return isHTMLSelectElement(*element); }
inline bool isHTMLSelectElement(const Node* node) { ASSERT(node); return isHTMLSelectElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLSelectElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLSelectElement(node); }
};

class HTMLSourceElement;
void isHTMLSourceElement(const HTMLSourceElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLSourceElement(const HTMLSourceElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLSourceElement(const HTMLElement& element) { return !element.isHTMLUnknownElement() && element.hasTagName(HTMLNames::sourceTag); }
inline bool isHTMLSourceElement(const Node& node) { return node.isHTMLElement() && isHTMLSourceElement(toHTMLElement(node)); }
inline bool isHTMLSourceElement(const HTMLElement* element) { ASSERT(element); return isHTMLSourceElement(*element); }
inline bool isHTMLSourceElement(const Node* node) { ASSERT(node); return isHTMLSourceElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLSourceElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLSourceElement(node); }
};

class HTMLStyleElement;
void isHTMLStyleElement(const HTMLStyleElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLStyleElement(const HTMLStyleElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLStyleElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::styleTag); }
inline bool isHTMLStyleElement(const Node& node) { return node.hasTagName(HTMLNames::styleTag); }
inline bool isHTMLStyleElement(const HTMLElement* element) { ASSERT(element); return isHTMLStyleElement(*element); }
inline bool isHTMLStyleElement(const Node* node) { ASSERT(node); return isHTMLStyleElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLStyleElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLStyleElement(node); }
};

class HTMLSummaryElement;
void isHTMLSummaryElement(const HTMLSummaryElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLSummaryElement(const HTMLSummaryElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLSummaryElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::summaryTag); }
inline bool isHTMLSummaryElement(const Node& node) { return node.hasTagName(HTMLNames::summaryTag); }
inline bool isHTMLSummaryElement(const HTMLElement* element) { ASSERT(element); return isHTMLSummaryElement(*element); }
inline bool isHTMLSummaryElement(const Node* node) { ASSERT(node); return isHTMLSummaryElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLSummaryElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLSummaryElement(node); }
};

class HTMLTableElement;
void isHTMLTableElement(const HTMLTableElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTableElement(const HTMLTableElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTableElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::tableTag); }
inline bool isHTMLTableElement(const Node& node) { return node.hasTagName(HTMLNames::tableTag); }
inline bool isHTMLTableElement(const HTMLElement* element) { ASSERT(element); return isHTMLTableElement(*element); }
inline bool isHTMLTableElement(const Node* node) { ASSERT(node); return isHTMLTableElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTableElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTableElement(node); }
};

class HTMLTemplateElement;
void isHTMLTemplateElement(const HTMLTemplateElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTemplateElement(const HTMLTemplateElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTemplateElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::templateTag); }
inline bool isHTMLTemplateElement(const Node& node) { return node.hasTagName(HTMLNames::templateTag); }
inline bool isHTMLTemplateElement(const HTMLElement* element) { ASSERT(element); return isHTMLTemplateElement(*element); }
inline bool isHTMLTemplateElement(const Node* node) { ASSERT(node); return isHTMLTemplateElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTemplateElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTemplateElement(node); }
};

class HTMLTextAreaElement;
void isHTMLTextAreaElement(const HTMLTextAreaElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTextAreaElement(const HTMLTextAreaElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTextAreaElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::textareaTag); }
inline bool isHTMLTextAreaElement(const Node& node) { return node.hasTagName(HTMLNames::textareaTag); }
inline bool isHTMLTextAreaElement(const HTMLElement* element) { ASSERT(element); return isHTMLTextAreaElement(*element); }
inline bool isHTMLTextAreaElement(const Node* node) { ASSERT(node); return isHTMLTextAreaElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTextAreaElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTextAreaElement(node); }
};

class HTMLTitleElement;
void isHTMLTitleElement(const HTMLTitleElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTitleElement(const HTMLTitleElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTitleElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::titleTag); }
inline bool isHTMLTitleElement(const Node& node) { return node.hasTagName(HTMLNames::titleTag); }
inline bool isHTMLTitleElement(const HTMLElement* element) { ASSERT(element); return isHTMLTitleElement(*element); }
inline bool isHTMLTitleElement(const Node* node) { ASSERT(node); return isHTMLTitleElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTitleElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTitleElement(node); }
};

class HTMLTableRowElement;
void isHTMLTableRowElement(const HTMLTableRowElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTableRowElement(const HTMLTableRowElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTableRowElement(const HTMLElement& element) { return element.hasTagName(HTMLNames::trTag); }
inline bool isHTMLTableRowElement(const Node& node) { return node.hasTagName(HTMLNames::trTag); }
inline bool isHTMLTableRowElement(const HTMLElement* element) { ASSERT(element); return isHTMLTableRowElement(*element); }
inline bool isHTMLTableRowElement(const Node* node) { ASSERT(node); return isHTMLTableRowElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTableRowElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTableRowElement(node); }
};

class HTMLTrackElement;
void isHTMLTrackElement(const HTMLTrackElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLTrackElement(const HTMLTrackElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLTrackElement(const HTMLElement& element) { return !element.isHTMLUnknownElement() && element.hasTagName(HTMLNames::trackTag); }
inline bool isHTMLTrackElement(const Node& node) { return node.isHTMLElement() && isHTMLTrackElement(toHTMLElement(node)); }
inline bool isHTMLTrackElement(const HTMLElement* element) { ASSERT(element); return isHTMLTrackElement(*element); }
inline bool isHTMLTrackElement(const Node* node) { ASSERT(node); return isHTMLTrackElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLTrackElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLTrackElement(node); }
};

class HTMLVideoElement;
void isHTMLVideoElement(const HTMLVideoElement&); // Catch unnecessary runtime check of type known at compile time.
void isHTMLVideoElement(const HTMLVideoElement*); // Catch unnecessary runtime check of type known at compile time.
inline bool isHTMLVideoElement(const HTMLElement& element) { return !element.isHTMLUnknownElement() && element.hasTagName(HTMLNames::videoTag); }
inline bool isHTMLVideoElement(const Node& node) { return node.isHTMLElement() && isHTMLVideoElement(toHTMLElement(node)); }
inline bool isHTMLVideoElement(const HTMLElement* element) { ASSERT(element); return isHTMLVideoElement(*element); }
inline bool isHTMLVideoElement(const Node* node) { ASSERT(node); return isHTMLVideoElement(*node); }
template <typename ArgType>
struct ElementTypeCastTraits<const HTMLVideoElement, ArgType> {
    static bool is(ArgType& node) { return isHTMLVideoElement(node); }
};

}

#endif
