/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SQL_DATABASE)

#include "JSSQLTransactionSync.h"

#include "JSDOMBinding.h"
#include "SQLTransactionSync.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsSQLTransactionSyncPrototypeFunctionExecuteSql(JSC::ExecState*);

class JSSQLTransactionSyncPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSSQLTransactionSyncPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSQLTransactionSyncPrototype* ptr = new (NotNull, JSC::allocateCell<JSSQLTransactionSyncPrototype>(vm.heap)) JSSQLTransactionSyncPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSQLTransactionSyncPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSSQLTransactionSyncPrototypeTableValues[] =
{
    { "executeSql", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsSQLTransactionSyncPrototypeFunctionExecuteSql), (intptr_t) (2) },
};

WEBCORE_EXPORT const ClassInfo JSSQLTransactionSyncPrototype::s_info = { "SQLTransactionSyncPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSSQLTransactionSyncPrototype) };

void JSSQLTransactionSyncPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSSQLTransactionSyncPrototypeTableValues, *this);
}

WEBCORE_EXPORT const ClassInfo JSSQLTransactionSync::s_info = { "SQLTransactionSync", &Base::s_info, 0, CREATE_METHOD_TABLE(JSSQLTransactionSync) };

JSSQLTransactionSync::JSSQLTransactionSync(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SQLTransactionSync> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

JSObject* JSSQLTransactionSync::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSSQLTransactionSyncPrototype::create(vm, globalObject, JSSQLTransactionSyncPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSSQLTransactionSync::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSSQLTransactionSync>(vm, globalObject);
}

void JSSQLTransactionSync::destroy(JSC::JSCell* cell)
{
    JSSQLTransactionSync* thisObject = static_cast<JSSQLTransactionSync*>(cell);
    thisObject->JSSQLTransactionSync::~JSSQLTransactionSync();
}

JSSQLTransactionSync::~JSSQLTransactionSync()
{
    releaseImplIfNotNull();
}

EncodedJSValue JSC_HOST_CALL jsSQLTransactionSyncPrototypeFunctionExecuteSql(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSSQLTransactionSync* castedThis = jsDynamicCast<JSSQLTransactionSync*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "SQLTransactionSync", "executeSql");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSSQLTransactionSync::info());
    return JSValue::encode(castedThis->executeSql(exec));
}

bool JSSQLTransactionSyncOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSSQLTransactionSyncOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSSQLTransactionSync* jsSQLTransactionSync = jsCast<JSSQLTransactionSync*>(handle.slot()->asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSQLTransactionSync->impl(), jsSQLTransactionSync);
    jsSQLTransactionSync->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, SQLTransactionSync* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSSQLTransactionSync>(globalObject, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to SQLTransactionSync.
    COMPILE_ASSERT(!__is_polymorphic(SQLTransactionSync), SQLTransactionSync_is_polymorphic_but_idl_claims_not_to_be);
#endif
    return createNewWrapper<JSSQLTransactionSync>(globalObject, impl);
}

SQLTransactionSync* toSQLTransactionSync(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSSQLTransactionSync*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(SQL_DATABASE)
