/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSharedWorker_h
#define JSSharedWorker_h

#if ENABLE(SHARED_WORKERS)

#include "JSEventTarget.h"
#include "SharedWorker.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSSharedWorker : public JSEventTarget {
public:
    typedef JSEventTarget Base;
    static JSSharedWorker* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SharedWorker> impl)
    {
        JSSharedWorker* ptr = new (NotNull, JSC::allocateCell<JSSharedWorker>(globalObject->vm().heap)) JSSharedWorker(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);
    void visitAdditionalChildren(JSC::SlotVisitor&);

    SharedWorker& impl() const
    {
        return static_cast<SharedWorker&>(Base::impl());
    }
protected:
    JSSharedWorker(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<SharedWorker>);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

class JSSharedWorkerOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, SharedWorker*)
{
    static NeverDestroyed<JSSharedWorkerOwner> owner;
    return &owner.get();
}

inline void* wrapperContext(DOMWrapperWorld& world, SharedWorker*)
{
    return &world;
}

WEBCORE_EXPORT JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, SharedWorker*);
WEBCORE_EXPORT SharedWorker* toSharedWorker(JSC::JSValue);

// Custom constructor
JSC::EncodedJSValue JSC_HOST_CALL constructJSSharedWorker(JSC::ExecState*);


} // namespace WebCore

#endif // ENABLE(SHARED_WORKERS)

#endif
