/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMDataCue.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMDataCuePrivate.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMTextTrackCuePrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#if ENABLE(VIDEO_TRACK)

namespace WebKit {

WebKitDOMDataCue* kit(WebCore::DataCue* obj)
{
    return WEBKIT_DOM_DATA_CUE(kit(static_cast<WebCore::TextTrackCue*>(obj)));
}

WebCore::DataCue* core(WebKitDOMDataCue* request)
{
    return request ? static_cast<WebCore::DataCue*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMDataCue* wrapDataCue(WebCore::DataCue* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_DATA_CUE(g_object_new(WEBKIT_DOM_TYPE_DATA_CUE, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(VIDEO_TRACK)

G_DEFINE_TYPE(WebKitDOMDataCue, webkit_dom_data_cue, WEBKIT_DOM_TYPE_TEXT_TRACK_CUE)

enum {
    PROP_0,
    PROP_TEXT,
};

static void webkit_dom_data_cue_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMDataCue* self = WEBKIT_DOM_DATA_CUE(object);

    switch (propertyId) {
    case PROP_TEXT:
        g_value_take_string(value, webkit_dom_data_cue_get_text(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_data_cue_class_init(WebKitDOMDataCueClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    gobjectClass->get_property = webkit_dom_data_cue_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_TEXT,
        g_param_spec_string(
            "text",
            "DataCue:text",
            "read-only gchar* DataCue:text",
            "",
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_data_cue_init(WebKitDOMDataCue* request)
{
    UNUSED_PARAM(request);
}

gchar* webkit_dom_data_cue_get_text(WebKitDOMDataCue* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_DATA_CUE(self), 0);
    WebCore::DataCue* item = WebKit::core(self);
    bool isNull = false;
    gchar* result = convertToUTF8String(item->text(isNull));
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

